#include "delayunit.h"
#include <iostream>
#include <iomanip>

DelayUnit::DelayUnit(int max)
    : m_pos(0), m_buffer(1, max), m_max(max)
{
}

DelayUnit::~DelayUnit()
{
}

void DelayUnit::write(float value)
{
    m_buffer.get()[0][m_pos] = value;
}

float DelayUnit::read(int delayTime)
{
    if (delayTime > m_max)
        delayTime = m_max;

    int readPos = m_pos - delayTime;
    if (readPos < 0)
        readPos += m_max;

    return m_buffer.get()[0][readPos];
}

void DelayUnit::tick()
{
    ++m_pos;

    if (m_pos >= m_max)
        m_pos -= m_max;
}

void DelayUnit::clear()
{
    m_buffer.clear();
}

void DelayUnit::dump()
{
    for (int frame = 0; frame < m_max; ++frame)
    {
        std::cout << std::setprecision(4) << m_buffer.get()[0][frame] << ",";
    }
    std::cout << std::endl;
}