#ifndef LINK_ENGINE_H
#define LINK_ENGINE_H

#include "chain.h"
#include "audiobuffer.h"
#include "effect.h"

#include <sndfile.hh>
#include <tinyxml2.h>
#include <string>

class Engine
{
    std::vector<ChainPtr> m_chains;
    tinyxml2::XMLDocument m_doc;

    const int BLOCKSIZE = 512;

    void loadFromXML(tinyxml2::XMLElement* rootNode);

public:
    Engine(const char* xmlFile);
    ~Engine();

    void run();

};

#endif // LINK_ENGINE_H
