#include "gain.h"

#include <iostream>

Gain::Gain(const EffectData& data)
    : Effect(data)
{
    this->addParam("gain", -100, 100, 1);
}

Gain::~Gain()
{
    // nothing special
}

void Gain::process(float** in, float** out, const int numChannels, const int numFrames)
{
    for (int frame = 0; frame < numFrames; ++frame)
    {
        for (int chan = 0; chan < numChannels; ++chan)
        {
            out[chan][frame] = in[chan][frame] * getParam("gain")->get_linear();
        }
        for (auto& param : getParamList())
        {
            param->tick();
        }
    }
}