#include <iostream>

#include "engine.h"
#include <stdexcept>

void printUsage()
{
    std::cout << "\nlinkEngine v0.1\nUsage:\n\tlinkEngine <CHAIN_XML>\n\nwhere <CHAIN_XML> is the path to an XML file describing a processing chain\n" << std::endl;
}


int main(int argc, char** argv)
{
    if (argc > 1)
    {
        try
        {
            Engine engine(argv[1]);
            engine.run();
        }
        catch (std::exception& e)
        {
            std::cout << e.what() << std::endl;
        }
        catch (...)
        {
            std::cout << "Unknown error thrown - can not recover" << std::endl;
        }
    }
    else {
        printUsage();
    }

    return 0;
}