#include "split.h"

#include <sstream>

Split::Split(const EffectData& data)
    : Effect(data)
{
    std::string outPathName;
    std::string outPathExt;

    outPathName = m_data.outFilePath.substr(0, m_data.outFilePath.find_last_of('.'));
    outPathExt = m_data.outFilePath.substr(m_data.outFilePath.find_last_of('.'));

    std::stringstream outFilePath;

    for (int ident = 0; ident < m_data.numChannels; ++ident)
    {
        outFilePath << outPathName << "-" << ident << outPathExt;

        SndfilePtr tmp(new SndfileHandle(outFilePath.str(), SFM_WRITE, m_data.format, 1, m_data.sampleRate));
        m_outFiles.push_back(std::move(tmp));

        outFilePath.str(std::string()); // clear stream
    }
}

Split::~Split()
{
}

void Split::process(float** in, float** out, const int numChannels, const int numFrames)
{
    for (int chan = 0; chan < numChannels; ++chan)
    {
        m_outFiles[chan]->writef(&in[chan][0], numFrames);
    }
}