SuperDiffuse_CompositionEnv
{
	var parent;

	*new { | concertGUI |
		^super.new.init(concertGUI);
	}

	init { | concert |
		parent = concert;
	}

	gui {
		var win;
		var layout;
		var recordButton;
		var headerFormatMenu;
		var sampleFormatMenu;

		win = Window("SuperDiffuse | Composition Environment");

		layout = VLayout();

		headerFormatMenu = PopUpMenu().items_(["CAF", "WAV", "AIFF"]);
		sampleFormatMenu = PopUpMenu().items_(["int16", "int24", "int32", "float"]);

		recordButton = Button()
		.states_([
			["Prepare"],["Start Record"], ["Stop Record"]
		])
		.action_({ | button |
			if(button.value == 1)
			{
				Server.default.recHeaderFormat = headerFormatMenu.item;
				Server.default.recSampleFormat = sampleFormatMenu.item;
				Server.default.prepareForRecord(nil, parent.concert.numOuts);
			}
			{
				if(button.value == 2)
				{
					Server.default.record;
					parent.play;
				}
				{
					parent.stop;
					Server.default.stopRecording;
				}
			}
		});


		layout.add(headerFormatMenu);
		layout.add(sampleFormatMenu);
		layout.add(recordButton);

		win.layout = layout;
		win.front;
	}
}